**
** Profile for Regain aliases and programmable editing and function keys. **
** The top line sets a double asterisk as the comment indicator.
** If there is more than 1 group of characters on the top line, then the comment
** indicator is undefined and comments are not permitted in the file.
** Be sure that your choice of comment symbol does not conflict with real
** data in your regain profile file.

** ********* Set up aliases for checking the drive directories this will also
** ********* default to the current directory****************************

DA DIR A:                     ** DA is for directory in A: drive
DB DIR B:                     ** DB is for directory in B: drive
CC DIR C:                     ** DC is for directory in C: drive
DD DIR D:                     ** DD is for directory in D: drive
DE DIR E:                     ** DE is for directory in E: drive
DF DIR F:                     ** DF is for directory in F: drive
DG DIR G:
** The listings below will allow changing to the drive by only hitting the 2
** keys
DD D:                         ** CD is to change to Drive D:
CE E:                         ** CE is to change to Drive E:
CF F:                         ** CF is to change to Drive F:
CG G:                         ** CG is to change to Drive G:
**
** The TP is a short command for "TYPE". The TY is short for typing the file
** NoGames.CMT in the UTIL sub-directory to the screen.
**
TP TYPE
TY TYPE C:\UTIL\NOGAMES.CMT
TG TYPE C:\UTIL\NOGAMESC.CMT
CA CHKDSK A: *.*
CDDB CD\DBASE\DATA\BACKUP
CD1 CD\ARC1
CD2 CD\ARC2
CD3 CD\NET30
CD4 CD\ARC4
CD7 CD\171A
CD7D CD\171A\DATA
CDJ CD\JEFF
CDA CD\ASM
CDDS CD\DOS
CDQ CD\QMOD4
CDTP CD\PS2TAPE
CDS CD\SYS                    ** CDS is to change to directory SYS
CDT CD\TALK
CDU CD\UTIL                   ** CDU is to change to directory UTIL
CDW CD\WORK                   ** CDW is to change to directory WORK
CNN CD\NORT                   ** CNN is to change to directory NORT
CP1 CD\PRI1
CP2 CD\PRI2
** When I use the PE2 editor it is easier than typing the entire command string
** to edit the RBBS source code files Also with PE2 you must always be in the
** PE2 home directory.
PE21 PE2 RBBS-PC.BAS
PE22 PE2 RBBS-VAR.BAS
PE23 PE2 RBBSSUB1.BAS
PE24 PE2 RBBSSUB2.BAS
PE25 PE2 RBBSSUB3.BAS
PE26 PE2 RBBSSUB4.BAS
PE27 PE2 RBBSSUB5.BAS
QE QEMM
QER QEMMREG
QE QEMM
QEA QEMM ANALYSIS
QEM QEMM ACCESSED MAP
DC DCOM/OVL=G:\
DCC DCOM/OVLE
DCE DCOM/EMM
LH LOADHI
PA PKZIP -ex
PX PKUNZIP
PV PKUNZIP/V
PVV PKUNZIP/V *.ZIP
PT PKUNZIP/T
PTT PKUNZIP/T *.ZIP
ATP ATTRIB +R *.*
ATM ATTRIB -R *.*
ATT ATTRIB +A *.*
GT GTREE
COM COMPRESS
PM PMAP|MORE
MI MIRROR
SP SPACE
GT GTREE
WH WHIZ
WI WHEREIS
BR BROWSE
V VOPT
VC VOPT C:
VD VOPT D:
VE VOPT E:
VF VOPT F:
VI VTSR
PC3 PCTOOLS
NOGAMES FD *.*/D00/00/00~FD *.*/T00:00:00

** Set up an alias that will attach itself to the remainder of the typed
** command line without a separating space.
** Set up a simple multi-line file with substitution of variables to
** move a file from 1 drive to another with the form:move filename a: b:
** Personalize the function keys. *********************************************
** Program the pf keys or the top row number keys (with alt).
** Programming of the following keys is provided:
** PF1 thru PF10.
** PF1S thru PF10S    either Shift key held down.
** PF1A thru PF10A    Alt held down.
** PF1C thru PF10C    Ctrl held down.
** A1 thru A10        Top row keys 1 thru 9, and 0. Alt held down.

PF1S   CHKDSK *.*
PF2S   CHKDSK/F
PF3S   CHKDSK/V
PF4S   DISKCOPY A: B:
PF5S   DISKCOMP A: B:
PF6S   COPY *.* ?:\
PF7S   ERASE *.*
PF8S   DCOM
PF9S   TYPE H:\EDIT\NEW.MAI
PF10S  PROP/S

PF1A  DIR|MORE
PF2A  QSORT /30:2/24:2/27:2/R ALL.MAI
PF3A  QSORT /80:3 ALL.MAI
PF4A  QSORT ALL.MAI
PF5A  QSORT /30:2/24:2/27:2 ALL.MAI
PF6A  CFORMAT
PF7A  COPYIIPC A: B:
PF8A  PE2 RBBS-PC.BAS
PF9A  PE2 RBBSSUB?.BAS
PF10A cr BURNOUT 65000
PF11A cr BURNOUT 100
PF12A cr BURNOUT 0

PF1 cr DIR
PF2 cr GO
PF3 A:
PF4 cr C:
PF5 B:
PF6 cr D:
PF7 cr G:~PARK
PF8 cr CLS~CD\~CLS
PF9 cr CD\EDIT
PF10 ERASE *.*
PF11 RGO
PF12 cr RGO

A1 QB RBBS-PC.BAS/C:4096/O/S;
A2 QB RBBSSUB1.BAS/O/X/S;
A3 QB RBBSSUB2.BAS/O;
A4 QB RBBSSUB3.BAS/O;
A5 QB RBBSSUB4.BAS/O;
A6 QB RBBSSUB5.BAS/O;
A7 FD *.*/T00:00:00
A8 BULKERAS ?:/B
A9 RECV35

** Personalize the editing keys. **********************************************

** In general, both a normal and an extended key code may be specified for each
** function. In those cases where two mnemonics are provided, 2 normal and 2
** extended codes may be specified.

** All the key codes specified below are the defaults.

PSTK      0,72         ** Cursor Up     Roll stack to previous entry
NSTK      0,80         ** Cursor Down   Roll stack to next entry
NCHR      0,77         ** Cursor Right  Move to next chr
PCHR      0,75         ** Cursor Left   Move to previous chr
MBOL      0,71         ** Home          Move to beginning of line
MEOL      0,79         ** End           Move cursor to eol
MEOL2     0,79         ** End           A second option for eol
SETSTACK  0,73         ** Pgup          Recall the last line typed
RESSTACK  0,81         ** Pgdn          Recall the oldest line
TOGLWNDW  23           ** Ctrl-W        Toggle window display
VIEWALI   22           ** Ctrl-V        Toggle window display of aliases
USURPLIN  21           ** Ctrl-U        Usurp line from screen
DLINE     27           ** Esc           Delete line/clear screen
ENTER     13           ** Enter         Enter key
ENTER2    13           ** Enter2        2nd option for Enter key
NWORD     0,116        ** Ctrl-Right    Move to next word
PWORD     0,115        ** Ctrl-Left     Move to previous word
MTAB      0,15         ** Shift Tab     Move 1 tab position
TOGLINS   0,82         ** Insert        Toggle insert mode
RESETINS  17           ** Ctrl-Q        Reset insert mode
DSTK      0,118        ** Ctrl-Pgdn     Delete stack entry
CSTK      0,132        ** Ctrl-Pgup     Clear current stack
AUTOWNDW  20           ** Ctrl-T        Toggle auto window display
DCHR      0,83         ** Del           Delete chr
DWORD     24           ** Ctrl-X        Delete word
DEOL      0,117        ** Ctrl-End      Delete to end of line
DBOL      0,119        ** Ctrl-Home     Delete to beginning of line
BKSPC     127          ** Ctrl-Bkspc    Back space
BKSPC2    8            ** Bkspc         Back space
DISPLAYS  1            ** Ctrl-A        Display aliases
EDTALIAS  5            ** Ctrl-E        Edit alias or pf phrase
SETCMDBF  4            ** Ctrl-D        Identify present caller as command.com.
SETCMDB2  7            ** Ctrl-G        2nd option.
KEEPLINE  11           ** Ctrl-K        Save current line on stack
RSOLVALI  18           ** Ctrl-R        Resolve aliases for further editing
RSOLVABR  25           ** Ctrl-Y        Resolve abbreviations
FNSHNAME  12           ** Ctrl-L        Finish typing filename.ext
FINDCHR   6            ** Ctrl-F        Move cursor to next character.
FINDNEXT  14           ** Ctrl-N        Move cursor to next current chr.
FINDPREV  2            ** Ctrl-B        Move cursor to previous current chr.
OTHRSTAK  15           ** Ctrl-O        Switch to the other stack

** * * * * * *  Stack controls  * * * * * * *
MINSAV         3            ** Do not save lines containing less than 3 chrs.
SAVALL         0            ** Don't save commands that taken from the stack.
                            ** nz = save even if not edited.
SAVPFK         1            ** 1 = save pf lines only if cr is not included.
                            ** 2 or more = save all lines from pf keys.
                            ** 0 = save no lines if any pf key was involved.
STK1SIZ        5000         ** Size of command's stack
STK2SIZ        2500         ** Size of other stack
CMDSIZ         2500         ** size of resident command vector list
                            ** Minimum size is 14 bytes.
** * * * *   ALIAS & PF controls    * * * * *
APPNDPRO       0            ** Drop current definitions.
                            ** 1 = append to the current list
SAVE_IT        1024 B       ** Reserve 256 bytes for adding aliases
                            ** or pf definitions.
                            ** B=bytes; K=kilobytes; P=paragraphs (16 bytes)
                            ** Min = 16 bytes; max = 5000
NOALIAS         !           ** This specifies ! inhibit alias substitution.
ANESTING        10          ** Allow up to 10 levels of alias nesting.
                            ** Min = 0 ; max = 254
CRLFEED        126          ** This specifies the tilde (~) to represent
                            ** a carriage return or command separator.
                            ** This allows multiple commands to be called
                            ** by a single programmed key.
                            ** The value should be chosen with care and
                            ** must exceed 32.
                            ** Either the decimal ASCII code or the
                            ** character itself may be specified.
KEYINCR         96          ** This single closed quote (`) represents
                            ** a carriage return or command separator
                            ** that tells REGAIN that the next line of
                            ** text input is to come from the keyboard.
                            ** Comments for PFCRCHR apply here too.
BATCHR         %            ** Character to indicate substitution of a
                            ** variable.
ECHOOFF       0             ** 0 = display all multiple command lines
                            ** 1 = Inhibit echo of multiple commands to display
                            ** 2 = inhibit echo and do not give upward
                            ** line feeds.
PFECHOFF      0             ** Enables display of lines generated by PF keys.
                            ** 1 Inhibits display of same.
BATSIZ      128             ** Space allocated to hold multiple commands.
** * * * *   Miscellaneous controls    * * * * *
QUERYSYM       ?            ** Search command for previous line
EXECSYM        61           ** "=" Search  & execute command for previous line
LOCKINS        0            ** Insert is toggled.
                            ** 1 = Set with ins / Reset with Ctrl-Q
INSERTON       0            ** Default state of insert is off
                            ** 1 = Insert is normally on
BKSPCNTL       0            ** Backspace blanks the previous chr in insert mode.
                            ** 1 = Delete the previous chr when in insert mode.
WNDW           0            ** 1 = Display window automatically.
TITLE1   [NoGames BBS]     ** Window title @ DOS prompt
TITLE2   [NoGames HST]     ** Window title not @ DOS prompt
TITLEA    DVC Aliases       ** Alias list window title
WNDWCNTL       1            ** Enable number & sign keys to control window.
                            ** 0 = no control except by reinvocation
WNCOLUME       41           ** Column where left edge of window is placed.
WNDOWROW       14           ** Row where top edge of window is placed.
WNWIDE         40           ** Window width
WHEIGHT        12           ** Window height
WTRUNC         1            ** Truncate lines in window if non-zero.
                            ** Graphics symbols used for window display
FRAME-ES  176 176,176,176,176,176,16,17
**        horiz,vert,ul,  ur, lr, ll, >, <
CURSOR         7,12         ** Color and monochrome cursor lines
SETCURSR       0            ** Set cursor size automatically.
                            ** 1 = Set cursor size to REPCURSR and INSCURSR
REPCURSR       11,12        ** Replace mode cursor fills 11th to 12th lines
INSCURSR       6,12         ** Insert mode cursor fills 6th to 12th lines
EGACURSR       0            ** 0 Cursor handling for old Mono and color only
                            ** 1 for proper treatment of EGA/VGA
VIDATRIB       13           ** Video attrib to be used in window (color only)
                            ** The current attribute is used if zero.
VIDRATRB       14           ** Video attrib to be used on the currently
                            ** selected line of the window.
MONATRIB       7            ** Video attrib to be used in the mono window
                            ** The current attribute is used if zero.
MONRATRB       112          ** Video attrib to be used on the currently
                            ** selected line of the mono window.
WDIRECT        1            ** Write directly to video screen for speed.
NBRSYMBL       94           ** Defines the caret as the number symbol.
                            ** This symbol followed by a decimal number
                            ** in a pf string generates a character of
                            ** the equivalent ASCII code.
                            ** Either the decimal ASCII code or the
                            ** character itself may be specified.
EXEC3F         1            ** DOS is patched to call REGAIN for input
                            ** from the console (usually for dos call 3F).
SHOWIT         1            ** Display aliases as they are installed.
STDIO          2            ** Display goes to standard error device
                            ** 1 for standard output device
                            ** 0 for DOS character display (DOS function 2).
ABBREV         1            ** Environment strings are substituted.
ESCAPE         1            ** If 1, 2nd tap on Esc clears the screen.
FILATRIB       16           ** Attribute to use for filename finishing.
                            ** +2=hidden,+4=system,+16=directories,+8=vol.label
PROTRCAL       0            ** Don't protect against accidental stack recall.
                            ** If 1, no recall if line has been edited.
                            ** If 2, keep line temporarily, recall next.
                            ** If 3, keep line permanently, recall next.


